// order of variables in Q3...
//endogenous
// N capital stocks
// N productivities
// 1 consumption
//exogenous
// 1 aggregate shock
// N idiosyncratic shocks

double alpha = 0.36;
double delta = 0.025;
double phi = 2;
double gamma = 1;
double beta = 0.99;
double rho = 0.95;
//double zeta = 2; specialized for this value
double sigma = 0.005;
double N = 2;

double euler(const vec_double &x, const vec_double &u)
{
  vec_double x1(2*N+1);
  decision(x,u,x1);

  double omega = 1+phi*zeta*power(k1[0]-x[0],zeta-1)/(2*x[0]);
  return power(beta*integral1(f2,x1,Sigma_e_),gamma)/omega-x[2*N];
}

double f2(const vec_double &x1,const vec_double &u1)
{
  vec_double x2(2*N+1);
  decision(x1,u1,x2);
  double Z=0;
  for(int i=0; i < N; ++i)
    {
      Z += (x2[N+i]*power(x1[i],alpha)-x2[i]-(phi/2)*(x1[i]-x[i])*(x1[i]-x[i])/x[i]+(1-delta)*x[i]);
    }
  Z = (Z/N)*(1+(phi/x1[0])*(x2[0]-x1[0])+(phi/(2*x1[0]*x1[0]))*(x2[0]-x1[0])*(x2[0]-x1[0])-delta-alpha*x2[N]*power(x1[0],alpha-1));
  return Z;
}

void decision(vec_double &x, vec_double &u, vec_double &y)
{
}
