#if defined MTL_FCALL
#undef MTL_FCALL
#define MTL_FCALL(x) x##_
#endif

namespace mtl_lapack_dispatch {
  extern "C" {
    void MTL_FCALL(dpotrf)(const char &uplo, const int &n, double da[], const int &lda, int&info);
  }

  inline void potrf(const char &uplo, const int &n, double da[], const int &lda, int&info)
    {
      MTL_FCALL(dpotrf)(uplo, n, da, lda, info);
    }
}

namespace mtl2lapack {
  template <class LapackMatA>
    int potrf(const char &uplo, LapackMatA a)
    {
      int _info;
      int _lda = a.minor();
      int n = a.major();

      if (a.nrows() != a.ncols())
	{
	  return -100;
	}

      mtl_lapack_dispatch::potrf(uplo, n, a.data(), _lda, _info);

      return _info;
    }
}
