#include "dynare2.h"
#include "mtl/mtl2lapack.h"

typedef mtl2lapack::lapack_matrix<double>::type Lapack_Mat;

class Moments{
 public:
  Moments(){}
  Moments(int i)
    : vcov(i,i)
    {
      var_nbr = i;
      vcov_row = 0;
      vcov_col = 0;
      vcov_triang = 0;
    }
  
  void push(const char *);
  void push(const char *, const int);
  void push(const double );
  void set_variance(const char*, const double);
  void row_inc(void);
  const Lapack_Mat& getVcov() const
	  {return vcov;}
  inline MatA & chol()
    {
      return chol_vcov;
    }
 private:
  Lapack_Mat vcov;
  MatA chol_vcov;
  int vcov_row;
  int vcov_col;
  int vcov_triang;
  int var_nbr;
};





