std::vector<type_variable_table::iterator> variables_it;

void make_matlab_variable(t_my_ref arg, char *buffer)
{
  if (arg == NODE0) strcpy(buffer,"0");
  else if (arg == NODE1) strcpy(buffer,"1");
  else
    {  
      int a = (int)((tm_it)arg)->result;
      if (a > 0)
	{
	  type_variable_table::iterator vi = variables_it[a-1];
	  if ((*vi).second.type == 0)
	    {
	      if ((*vi).first.lag == 0)
		{
		  sprintf(buffer,"ex_(%d,it_-ykmin_+xkmin_)",(*vi).second.nbr);
		}
	      else
		{
		  sprintf(buffer,"ex_(%d,it_-ykmin_+xkmin_%+d)",(*vi).second.nbr,(*vi).first.lag);
		}
	    }
	  else if ((*vi).second.type == 1)
	    {
	      if ((*vi).first.lag == 0)
		{
		  sprintf(buffer,"y_(it_,%d)",(*vi).second.nbr);
		}
	      else
		{
		  sprintf(buffer,"y_(it_%+d,%d)",(*vi).first.lag,(*vi).second.nbr);
		}
	    }
	  else if ((*vi).second.type == 3)
	    {
	      strcpy(buffer,(*vi).first.name);
	    }
	  else
	    {
	      cerr << "Error in variable type";
	      exit(1);
	    }
	}
      else
	{
	  sprintf(buffer,"t%d_",((tm_it)arg)->no);
	}
    }
}

void print_matlab_model(int deriv_order)
{
  std::ofstream to_file("ff_.m");
  to_file << "function [z_,g_]=ff_(y_);\n";
  to_file << "z_=zeros(" << endo_nbr << ",1);\n";
  int k1 = endo_nbr;
  int k2 = 1;
  for (int i=1; i < deriv_order; i++)
    {
      k1 *= endo_nbr + i;
      k2 *= (i+1);
    }
  k1 = (int)(k1/k2);
  //  to_file << "g_=spalloc(" << endo_nbr << "," << k1 << "," << (int)(k1/endo_nbr) << ");\n";

  // initializes variables for C++ function
  {
    type_variable_table::iterator j=variables.begin();
    cerr << "initialize\n";
    for (int i=1; i <= variables.size(); i++)
      {
	((tm_it)(j->second).address)->result = i;
	variables_it.push_back(j);
	j++;
      }
  }

  int tnbr = 1;
  for (std::list<s_node>::iterator i = model.begin(); i != model.end(); i++)
    {
      if (i->code == 0) continue;

      if (i->code != EQUAL_SIGN) i->no = tnbr++;

      char pc1[200], pc2[200];

      make_matlab_variable((*i).arg1,pc1);
      make_matlab_variable((*i).arg2,pc2);

      switch (i->code)
	{
	case PLUS:
	  to_file << "t" << i->no << "_=" << pc1 << "+" << pc2 << ";\n";
	  break;
	case MINUS:
	  if ((*i).arg1 != NODE0)
	    {
	      to_file << "t" << i->no << "_=" << pc1 << "-" << pc2 << ";\n";
	    }
	  else
	    {
	      to_file << "t" << i->no << "_=" << "-" << pc2 << ";\n";
	    }
	  break;
	case DIVIDE:
	  to_file << "t" << i->no << "_=" << pc1 << "/" << pc2 << ";\n";
	  break;
	case TIMES:
	  to_file << "t" << i->no << "_=" << pc1 << "*" << pc2 << ";\n";
	  break;
	case EXP:
	  to_file << "t" << i->no << "_=exp(" << pc2 << ");\n";
	  break;
	case LOG:
	  to_file << "t" << i->no << "_=log(" << pc2 << ");\n";
	  break;
	case LOG10:
	  to_file << "t" << i->no << "_=log10(" << pc2 << ");\n";
	  break;
	case COS:
	  to_file << "t" << i->no << "_=cos(" << pc2 << ");\n";
	  break;
	case SIN:
	  to_file << "t" << i->no << "_=sin(" << pc2 << ");\n";
	  break;
	case TAN:
	  to_file << "t" << i->no << "_=tan(" << pc2 << ");\n";
	  break;
	case ACOS:
	  to_file << "t" << i->no << "_=acos(" << pc2 << ");\n";
	  break;
	case ASIN:
	  to_file << "t" << i->no << "_=asin(" << pc2 << ");\n";
	  break;
	case ATAN:
	  to_file << "t" << i->no << "_=atan(" << pc2 << ");\n";
	  break;
	case COSH:
	  to_file << "t" << i->no << "_=cosh(" << pc2 << ");\n";
	  break;
	case SINH:
	  to_file << "t" << i->no << "_=sinh(" << pc2 << ");\n";
	  break;
	case TANH:
	  to_file << "t" << i->no << "_=tanh(" << pc2 << ");\n";
	  break;
	case ACOSH:
	  to_file << "t" << i->no << "=_acosh(" << pc2 << ");\n";
	  break;
	case ASINH:
	  to_file << "t" << i->no << "=_asinh(" << pc2 << ");\n";
	  break;
	case ATANH:
	  to_file << "t" << i->no << "=_atanh(" << pc2 << ");\n";
	  break;
	case SQRT:
	  to_file << "t" << i->no << "=_sqrt(" << pc2 << ");\n";
	  break;
	case POWER:
	  to_file << "t" << i->no << "_=" << pc1 << "^" << pc2 << ";\n";
	  break;
	case EQUAL_SIGN:
	  if (i->no == 0)
	    {
	      to_file << "z_(" << i->ref+1 << ")=" << pc2 <<";\n";
	    }
	  else
	    {
	      to_file << "g_(" << i->ref+1 << "," << deriv_col[i->no].col << ")=" << pc2;
	    }
	  break;
	default:
	  cerr << "Missing code:" << i->code;
	}
    }
}

void make_c_variable(t_my_ref arg, char *buffer)
{
  if (arg == NODE0) strcpy(buffer,"0");
  else if (arg == NODE1) strcpy(buffer,"1");
  else
    {  
      int a = (int)((tm_it)arg)->result;
      if (a > 0)
	{
	  type_variable_table::iterator vi = variables_it[a-1];
	  if ((*vi).second.type == 0)
	    {
	      if ((*vi).first.lag == 0)
		{
		  sprintf(buffer,"ex(_it,%d)",(*vi).second.nbr);
		}
	      else
		{
		  sprintf(buffer,"ex(_it+%d,%d)",(*vi).first.lag,(*vi).second.nbr);
		}
	    }
	  else if ((*vi).second.type == 1)
	    {
	      if ((*vi).first.lag == 0)
		{
		  sprintf(buffer,"y(_it,%d)",(*vi).second.nbr);
		}
	      else
		{
		  sprintf(buffer,"y(_it%+d,%d)",(*vi).first.lag,(*vi).second.nbr);
		}
	    }
	  else if ((*vi).second.type == 3)
	    {
	      sprintf(buffer,"param[%d]",(*vi).second.nbr-1);
	    }
	  else
	    {
	      cerr << "Error in variable type";
	      exit(1);
	    }
	}
      else
	{
	  sprintf(buffer,"t%d",((tm_it)arg)->no);
	}
    }
}

int gnbr = 0;
void print_c_model(int deriv_order)
{
  std::ofstream to_file("ff_.cc");
  to_file << "#include <math.h>\n";
  to_file << "#include <mtl/mtl.h>\n";
  to_file << "#include <mtl/matrix.h>\n";
  to_file << "typedef mtl::matrix< double,\n mtl::rectangle<>,\n mtl::array< mtl::dense<> >,\n mtl::row_major>::type MatA;\n";
  to_file << "typedef mtl::dense1D<double> vec_double;\n\n";
  to_file << "void ff_(vec_double & z,double *g_v, int *g_i, int *g_r, MatA &y, MatA & ex, vec_double &param, int _it, int deriv_order)\n{\n";

  // initializes variables for C++ function
  {
    type_variable_table::iterator j=variables.begin();
    cerr << "initialize\n";
    for (int i=1; i <= variables.size(); i++)
      {
	((tm_it)(j->second).address)->result = i;
	variables_it.push_back(j);
	j++;
      }
  }

  int tnbr = 1;
  for (std::list<s_node>::iterator i = model.begin(); i != model.end(); i++)
    {
      if (i->code == 0) continue;

      if (i->code != EQUAL_SIGN) i->no = tnbr++;

      char pc1[200], pc2[200];

      make_c_variable((*i).arg1,pc1);
      make_c_variable((*i).arg2,pc2);

      switch (i->code)
	{
	case PLUS:
	  to_file << "double t" << i->no << "=" << pc1 << "+" << pc2 << ";\n";
	  break;
	case MINUS:
	  if ((*i).arg1 != NODE0)
	    {
	      to_file << "double t" << i->no << "=" << pc1 << "-" << pc2 << ";\n";
	    }
	  else
	    {
	      to_file << "double t" << i->no << "=" << "-" << pc2 << ";\n";
	    }
	  break;
	case DIVIDE:
	  to_file << "double t" << i->no << "=" << pc1 << "/" << pc2 << ";\n";
	  break;
	case TIMES:
	  to_file << "double t" << i->no << "=" << pc1 << "*" << pc2 << ";\n";
	  break;
	case EXP:
	  to_file << "double t" << i->no << "=exp(" << pc2 << ");\n";
	  break;
	case LOG:
	  to_file << "double t" << i->no << "=log(" << pc2 << ");\n";
	  break;
	case LOG10:
	  to_file << "double t" << i->no << "=log10(" << pc2 << ");\n";
	  break;
	case COS:
	  to_file << "double t" << i->no << "=cos(" << pc2 << ");\n";
	  break;
	case SIN:
	  to_file << "double t" << i->no << "=sin(" << pc2 << ");\n";
	  break;
	case TAN:
	  to_file << "double t" << i->no << "=tan(" << pc2 << ");\n";
	  break;
	case ACOS:
	  to_file << "double t" << i->no << "=acos(" << pc2 << ");\n";
	  break;
	case ASIN:
	  to_file << "double t" << i->no << "=asin(" << pc2 << ");\n";
	  break;
	case ATAN:
	  to_file << "double t" << i->no << "=atan(" << pc2 << ");\n";
	  break;
	case COSH:
	  to_file << "double t" << i->no << "=cosh(" << pc2 << ");\n";
	  break;
	case SINH:
	  to_file << "double t" << i->no << "=sinh(" << pc2 << ");\n";
	  break;
	case TANH:
	  to_file << "double t" << i->no << "=tanh(" << pc2 << ");\n";
	  break;
	case ACOSH:
	  to_file << "double t" << i->no << "=acosh(" << pc2 << ");\n";
	  break;			      
	case ASINH:			      
	  to_file << "double t" << i->no << "=asinh(" << pc2 << ");\n";
	  break;			      
	case ATANH:			      
	  to_file << "double t" << i->no << "=atanh(" << pc2 << ");\n";
	  break;			      
	case SQRT:			      
	  to_file << "double t" << i->no << "=sqrt(" << pc2 << ");\n";
	  break;
	case POWER:
	  to_file << "double t" << i->no << "=pow(" << pc1 << "," << pc2 << ");\n";
	  break;
	case EQUAL_SIGN:
	  if (i->no == 0)
	    {
	      to_file << "z[" << i->ref+1 << "]=" << pc2 <<";\n";
	    }
	  else
	    {
	      to_file << "g_v[" << gnbr << "]= " << pc2;
	      to_file <<";\n";
	      to_file << "g_i[" << gnbr << "]= " << deriv_col[i->no].col;
	      to_file <<";\n";
	      to_file << "g_r[" << gnbr << "]= " << i->ref+1;
	      to_file <<";\n";
	      gnbr++;
	    }
	  break;
	default:
	  cerr << "Missing code:" << i->code;
	}
    }
  to_file << "return;\n}\n";
  to_file.close();
  system("gcc -g -c ff_.cc");
  system("gcc -g -shared -mno-cygwin ff_.o -o ff_.dll");
}
