#include "dynare2.h"
#include "my_mtl.h"

void sub_sparse(Mat & A, Matx0 & B, int start, int nbr)
{
  if ( nbr > A.nrows())
    {
      cerr << "sub_sparse error\n";
      exit(1);
    }
  int * new_ptr = new int[nbr+1];
  int * ptr = A.get_ptr();
  double *new_val = A.get_val()+ptr[start];
  int *new_ind = A.get_ind()+ptr[start];
  int offset = ptr[start];
  for (int i = 0; i <= nbr; i++)
    {
      new_ptr[i] = ptr[start+i]-offset;
    }
  B = Matx0(nbr,A.minor(),new_ptr[nbr],new_val,new_ptr,new_ind);
}


