#include "my_mtl.h"
// need to add dispatch by orientation

template <class MatA>
void sub_sparse(MatA & A, Matx0 & B, int start, int nbr)
{
  if ( start+nbr > A.nrows())
    {
      std::cout << "sub_sparse error\n";
      exit(1);
    }
  int * new_ptr = new int[nbr+1];
  int * ptr = A.get_ptr();
  double *new_val = A.get_val()+ptr[start];
  int *new_ind = A.get_ind()+ptr[start];
  int offset = ptr[start];
  for (int i = 0; i <= nbr; i++)
    {
      new_ptr[i] = ptr[start+i]-offset;
    }
  B = Matx0(nbr,A.minor(),new_ptr[nbr],new_val,new_ptr,new_ind);
}

template <class MatA>
void sub_sparse(MatA & A, Matx0 & B, int start, int nbr, int empty_rows)
{
  if ( start+nbr > A.nrows())
    {
      std::cout << "sub_sparse error\n";
      exit(1);
    }
  int * new_ptr = new int[empty_rows+nbr+1];
  int * ptr = A.get_ptr();
  double *new_val = A.get_val()+ptr[start];
  int *new_ind = A.get_ind()+ptr[start];
  int offset = ptr[start];
  for (int i = 0; i < empty_rows; ++i)
    {
      new_ptr[i] = 0;
    }
  for (int i = 0; i <= nbr; i++)
    {
      new_ptr[i+empty_rows] = ptr[start+i]-offset;
    }
  B = Matx0(nbr+empty_rows,A.minor(),new_ptr[nbr+empty_rows],new_val,new_ptr,new_ind);
}

/*  template <class MatA, class MatB> */
/*  void sub_sparse_col(MatA & A, MatB &B, int start, int nbr) */
/*  { */
/*    typedef typename matrix_traits<MatA>::value_type T; */
/*    typedef typename matrix_traits<MatA>::size_type Int; */
/*    typedef typename dense1D<Int>::iterator di_iter; */
/*    typedef typename dense1D<T>::iterator dt_iter; */

/*    Int end1 = start+nbr; */
/*    if ( end1 > A.cols()) */
/*      { */
/*        cerr << "sub_sparse_col error\n"; */
/*        exit(1); */
/*      } */
/*    Int n = A.nnz(); */
/*    mtl::dense1D<Int> new_ptr(A.rows()+1); */
/*    di_iter i_new_ptr = new_ptr.begin(); */
/*    Int * ptr = A.get_ptr(); */
/*    mtl::dense1D<T> new_val(n); */
/*    dt_iter i_new_val = new_val.begin(); */
/*    double * val = A.get_val(); */
/*    mtl::dense1D<Int> new_ind(n); */
/*    di_iter i_new_ind = new_ind.begin(); */
/*    Int * ind = A.get_ind(); */
  
/*    Int k = 0; */
/*    for(int i = 0; i < n; ++i) */
/*      { */
/*        j = *ind; */
/*        if (j >= start && j < end1) */
/*  	{ */
/*  	  *(i_new_ind++) = j - start; */
/*  	  *(i_new_val++) = *val; */
/*  	  while ( i >= *ptr) */
/*  	    { */
/*  	      *i_new_ptr++ = k; */
/*  	      ++ptr; */
/*  	    } */
/*  	  ++k; */
/*  	} */
/*        ++ind; */
/*        ++val; */
/*      } */
/*    *new_ptr = k; */
/*    Matx temp(A.rows(),nbr,k,new_val.data(),new_ptr.data(),new_ind.data()); */
/*    copy(temp,B); */
/*  } */










