#include <iostream>
#include <string>
#include <sstream>

#include "dynare2.h"
#include "my_mtl.h"
#include "mtl/mtl2lapack.h"

extern int deriv_order;

int my_criteria(double *alphar, double *alphai, double *beta)
{
  return( (*alphar * *alphar + *alphai * *alphai) < *beta * *beta);
}

vec_int i_sort(const vec_int & a)
{
  vec_int i(a.size());

  vec_int::iterator j;
  int n = 1;
  for(j=i.begin(); j != i.end(); j++)
    {
      *j = n;
      n++;
    }

  bool changed = 1;
  while ( changed )
    {
      changed = 0;
      j=i.begin();
      for (vec_int::iterator j1=i.begin()+1; j1 != i.end(); j1++)
	{
	  if (a[*j-1] < a[*j1-1])
	    {
	      int temp = *j1;
	      *j1 = *j;
	      *j = temp;
	      changed = 1;
	    }
	  j = j1;
	}
    }
  return i;
}

void set_deriv_order(char *number)
{
  std::istringstream is(number);
  is >> deriv_order;
} 
